//
//  ViewController.swift
//  testCoreData
//
//  Created by Andres Käver on 17/05/2019.
//  Copyright © 2019 TalTech IT College - Andres Käver. All rights reserved.
//

import UIKit
import CoreData

class MainViewController: UIViewController {
    
    var container: NSPersistentContainer!
    var  personRepository: PersonRepository!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        guard container != nil else {
            fatalError("This view requiers NSPersistentContainer")
        }
        // here we now have container
        
        personRepository = PersonRepository(withContainer: container)
        
        let person = Person(context: personRepository.context)
        person.firstName = "Jyri"
        person.lastName = "Kuusk"
        do {
            try personRepository.insert(person: person)
        }
        catch {
            print("Failed saving")
        }
        
        do {
            let persons = try personRepository.all()
            for person in persons {
                print(person.firstName!)
                print(person.lastName!)
            }
        } catch {
            print("Failed loading")

        }
        //insertData()
        //loadData()
    }
    
    func insertData(){
        let context = container.viewContext
        let entity = NSEntityDescription.entity(forEntityName: "Person", in: context)
        let newPerson = NSManagedObject(entity: entity!, insertInto: context)
        newPerson.setValue("Andres", forKey: "firstName")
        newPerson.setValue("Käver", forKey: "lastName")
        do {
            try context.save()
        } catch {
            print("Failed saving")
        }
        
    }
    
    func loadData(){
        let context = container.viewContext
        let request = NSFetchRequest<NSFetchRequestResult>(entityName: "Person")
        request.predicate = NSPredicate(format: "firstName = %@", "Andres")
        request.returnsObjectsAsFaults = false
        do {
            let result = try context.fetch(request)
            for data in result as! [NSManagedObject] {
                print(data.value(forKey: "firstName") as! String)
                print(data.value(forKey: "lastName") as! String)
            }
        } catch {
            print("Failed fetching")
        }
    }
    
    
}

