//
//  PersonRepository.swift
//  testCoreData
//
//  Created by Andres Käver on 17/05/2019.
//  Copyright © 2019 TalTech IT College - Andres Käver. All rights reserved.
//

import Foundation
import CoreData

class PersonRepository {
    
    var container: NSPersistentContainer!
    var context: NSManagedObjectContext {
        return container.viewContext
    }
    
    init(withContainer container: NSPersistentContainer){
        self.container = container
    }
    
    func all() throws -> [Person] {
        let persons = try context.fetch(Person.fetchRequest() as NSFetchRequest<Person>)
        return persons
    }
    
    func insert(person: Person) throws {
        context.insert(person)
        try context.save()
    }
    func update(person: Person) throws {
        try context.save()
    }
    func delete(person: Person) throws {
        context.delete(person)
        try context.save()
    }
}
